<?php
/**
 * Plugin Name: User Custom Discount
 * Plugin URI: https://www.beeplugin.com/
 * Description: User specific custom discount option.
 * Version: 1.0
 * Author: BeePlugin
 * Author URI: https://www.beeplugin.com
 */
register_activation_hook(__FILE__, 'beeplug_ucdp_beePluginTables');

function beeplug_ucdp_beePluginTables() {
  global $wpdb;
  $charset_collate = $wpdb->get_charset_collate();
  $table_name = $wpdb->prefix . 'customer_discount';
  $sql = "CREATE TABLE `$table_name` (
	  `id` int(11) NOT NULL AUTO_INCREMENT,
	  `cust_id` int(11) NOT NULL,
	  `cat_id` int(11) NOT NULL,
	  `scat_id` int(11) NOT NULL,
	  `prod_id` int(11) NOT NULL,
	  `disc_per` int(11) NOT NULL,
	  `is_category` int(11) NOT NULL DEFAULT 0,
	  PRIMARY KEY(id)
  ) ENGINE=MyISAM DEFAULT CHARSET=latin1;
  ";

  if ($wpdb->get_var("SHOW TABLES LIKE '$table_name'") != $table_name) {
    require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
    dbDelta($sql);
  }
}
function beeplug_ucdp_inits() {
	// wp_enqueue_style( 'style', plugins_url('css/bootstrap.min.css', __FILE__));
	// wp_enqueue_script( 'script', plugins_url('js/bootstrap.min.js', __FILE__));
	//wp_enqueue_style( 'user-style', plugins_url('css/user_style.css', __FILE__));
	add_action('admin_enqueue_scripts', 'beeplug_ucdp_load_scripts');
	
	//wp_enqueue_style( 'style', 'https://maxcdn.bootstrapcdn.com/bootstrap/3.3.6/css/bootstrap.min.css');
	//wp_enqueue_script( 'script', 'https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js');
}
add_action('init', 'beeplug_ucdp_inits');

function beeplug_ucdp_load_scripts($hook) { 

	wp_enqueue_style('bootstrap_style',plugins_url('css/bootstrap.min.css', __FILE__) );
	wp_enqueue_style('user-css', plugins_url('css/user_style.css', __FILE__) );
	wp_enqueue_script( 'bootstrap-js',  plugins_url('js/bootstrap.bundle.min.js', __FILE__) );
	wp_enqueue_script( 'user-js', plugins_url('js/user_script.js', __FILE__) );
	
}

add_action('admin_menu', 'beeplug_ucdp_setup_menu');
 
function beeplug_ucdp_setup_menu(){
        add_menu_page( 'Manage Customer Discount', 'Manage Customer Discount', 'manage_options', 'user-custom-discount', 'beeplug_ucdp_init' );
}
function beeplug_ucdp_init(){
			$args = array(
			    'role'    => 'Customer',
			    'orderby' => 'first_name',
			    'order'   => 'ASC'
			);
			$users = get_users( $args );
			$bee_users="";
	?>
	
        <div class="container">
			<h3 align="center">Manage User Discount on Categories / SubCategories / Products</h3>
			<br />
			<h4 align="center">Enter Discount Details</h4>
			<br />
			<textarea id="txt_holder"></textarea>
			<form method="post" id="insert_form">
				<div class="table-repsonsive">
					<span id="error"></span>
					<table class="table table-bordered" id="item_table">
						<tr>
						   <th>Select User</th>
						   <th><select name="cust_list" class="form-control cust_list">
						   	<option value="">Select Customer</option>
						   	<?php
							foreach ( $users as $user )
							  {
							  	?>
							  	<option value="<?php echo sanitize_text_field($user->ID);?>"><?php echo sanitize_text_field($user->first_name);?> (<?php echo sanitize_email($user->user_email);?>)</option>';
							 <?php
							  }						  
							 
						   	?>
						   	</select>
						   </th>
						   <th>&nbsp;</th>
						   <th>&nbsp;</th>
						   <th>&nbsp;</th>
						   
					  	</tr>
						<tr>
						   <th>Select Category</th>
						   <th>Select Sub Category</th>
						   <th>Select Product</th>
						   <th>Enter Discount %</th>
						   <th><button type="button" name="add" class="btn btn-success btn-sm add">+</button></th>
					  </tr>
					</table>
					<div align="center">
						<input type="hidden" name="action"  value="beeplug_ucdp_discount_insert_action" />
					<input type="submit" name="submit" class="btn btn-info" value="Insert" />
					</div>
				</div>
			</form>
		</div>
<?php 

}


add_action('wp_ajax_beeplug_ucdp_get_discount_list_action', 'beeplug_ucdp_get_discount_list_function');
function beeplug_ucdp_get_discount_list_function(){

	$cust_id=sanitize_text_field($_POST['cust_id']);
	$result_data="";
	$resultArray = array();
	global $wpdb;
	$bee_table = $wpdb->prefix.'customer_discount';
	$user_query = "SELECT * FROM $bee_table WHERE `cust_id` = %d";
	$user_query = $wpdb->prepare($user_query, array($cust_id));
	$result_disc_list = $wpdb->get_results($user_query);
	$disc_count_list=count($result_disc_list);$j=0;
	if($result_disc_list)
	{
		//Get All Category
		$orderby = 'name';
		$order = 'asc';
		$hide_empty = false ;
		$cat_args = array(
		    'orderby'    => $orderby,
		    'order'      => $order,
		    'hide_empty' => $hide_empty,
		    'parent' => 0
		);
		$product_categories = get_terms( 'product_cat', $cat_args );
		foreach ( $result_disc_list as $disc_list )
		{
		   $cat_id=$disc_list->cat_id;
		   $scat_id=$disc_list->scat_id;
		   $prod_id=$disc_list->prod_id;
		   $disc_per=$disc_list->disc_per;		   
		   foreach ($product_categories as $key => $category) {
		   		if($category->term_id==$cat_id){$str="selected";}else{$str="";}
				$bee_cat_list[$j][]=array(
										'cat_id' => $category->term_id,
										'cat_name' => $category->name,
										'cat_sel' => $str, 
									);
			} 
				$pcat_id=$cat_id;
				$args = array(
			       'hierarchical' => 1,
			       'show_option_none' => '',
			       'hide_empty' => 0,
			       'parent' => $pcat_id,
			       'taxonomy' => 'product_cat'
		   		);				
			  	$subcats = get_categories($args);			    
			    foreach ($subcats as $sc) {
			    	if($sc->term_id==$scat_id){$cstr="selected";}else{$cstr="";}
			    	$bee_subcat_list[$j][] = array(
			    							'scat_id' => $sc->term_id,
											'scat_name' => $sc->name,
											'scat_sel' => $cstr,
			    						);
			    }		  	
		   		if($scat_id==0)
		   			$pdcat_id=$cat_id;
		   		else
		   			$pdcat_id=$scat_id;
		   		
				$args = array(
			    'post_type'             => 'product',
			    'post_status'           => 'publish',
			    'ignore_sticky_posts'   => 1,
			    'posts_per_page'        => '12',
			    'tax_query'             => array(
				        array(
				            'taxonomy'      => 'product_cat',
				            'field' => 'term_id', //This is optional, as it defaults to 'term_id'
				            'terms'         => $pdcat_id,
				            'operator'      => 'IN' // Possible values are 'IN', 'NOT IN', 'AND'.
				        ),
				        array(
				            'taxonomy'      => 'product_visibility',
				            'field'         => 'slug',
				            'terms'         => 'exclude-from-catalog', // Possibly 'exclude-from-search' too
				            'operator'      => 'NOT IN'
				        )
			    	)
				);
				$loop = new WP_Query($args);
				$result_data.='<option value="">Select Product</option>';
				while ( $loop->have_posts() ) : $loop->the_post(); global $product; 
							if($loop->post->ID==$prod_id){$pstr="selected";}else{$pstr="";}
							$bee_prod_list[$j][] = array(
			    							'prod_id' => $loop->post->ID,
											'prod_name' => $loop->post->post_title,
											'prod_sel' => $pstr,
			    						);
				endwhile; 
		   $bee_discount_data[$j][]=$disc_per;		   
		  $j+=1;
		}
	}
	else
	{

	}   
    $resultArray=array('bee_cat' => $bee_cat_list, 'bee_scat' => $bee_subcat_list, 'bee_prod' => $bee_prod_list, 'discount_list' => $bee_discount_data, 'counter' => $disc_count_list);
    echo json_encode($resultArray);
    wp_die();
}

add_action('wp_ajax_beeplug_ucdp_category_action', 'beeplug_ucdp_category_function');
function beeplug_ucdp_category_function(){

	$orderby = 'name';
	$order = 'asc';
	$hide_empty = false ;
	$cat_args = array(
	    'orderby'    => $orderby,
	    'order'      => $order,
	    'hide_empty' => $hide_empty,
	    'parent' => 0
	);
	$catResultArray=array();
	$product_categories = get_terms( 'product_cat', $cat_args );

	if( !empty($product_categories) ){

		foreach ($product_categories as $key => $category) {
			$cat_id[]=$category->term_id;
			$cat_name[]=$category->name;
			
		}

	}
	$catResultArray=array('cat_ids' => $cat_id, 'cat_names' => $cat_name);
	echo json_encode($catResultArray);

    wp_die();

}

add_action('wp_ajax_beeplug_ucdp_subcategory_action', 'beeplug_ucdp_subcategory_function');

function beeplug_ucdp_subcategory_function(){
		$cat_id=sanitize_text_field($_POST['cat_id']);
		$args = array(
	       'hierarchical' => 1,
	       'show_option_none' => '',
	       'hide_empty' => 0,
	       'parent' => $cat_id,
	       'taxonomy' => 'product_cat'
	    );
		$subcat_stat=0;		
		$scatResultArray=array();
  		$subcats = get_categories($args);
    	$sub_cat_count=count($subcats);
    	if($sub_cat_count>0)
    	{	
		     $subcat_stat=1;		    
		      foreach ($subcats as $sc) {
		      	$scat_id[]=$sc->term_id;
				$scat_name[]=$sc->name;
			  }
		}
		else{
			
			$args = array(
		    'post_type'             => 'product',
		    'post_status'           => 'publish',
		    'ignore_sticky_posts'   => 1,
		    'posts_per_page'        => '12',
		    'tax_query'             => array(
		        array(
		            'taxonomy'      => 'product_cat',
		            'field' => 'term_id', //This is optional, as it defaults to 'term_id'
		            'terms'         => $cat_id,
		            'operator'      => 'IN' // Possible values are 'IN', 'NOT IN', 'AND'.
		        ),
		        array(
		            'taxonomy'      => 'product_visibility',
		            'field'         => 'slug',
		            'terms'         => 'exclude-from-catalog', // Possibly 'exclude-from-search' too
		            'operator'      => 'NOT IN'
		        )
		    )
		);
		$loop = new WP_Query($args);		
		while ( $loop->have_posts() ) : $loop->the_post(); global $product;
			$scat_id[]=$loop->post->ID;
			$scat_name[]=$loop->post->post_title;			
		endwhile;
		}
	  		$scatResultArray=array('scat_ids' => $scat_id, 'scat_names' => $scat_name, 'scat_count' => $sub_cat_count);
    		echo json_encode($scatResultArray);
    		wp_die();
}
add_action('wp_ajax_beeplug_ucdp_product_list_action', 'beeplug_ucdp_product_list_function');

function beeplug_ucdp_product_list_function(){
		$cat_id=sanitize_text_field($_POST['cat_id']);
		$subcatResultArray=array();
		$args = array(
	    'post_type'             => 'product',
	    'post_status'           => 'publish',
	    'ignore_sticky_posts'   => 1,
	    'posts_per_page'        => '12',
	    'tax_query'             => array(
	        array(
	            'taxonomy'      => 'product_cat',
	            'field' => 'term_id', //This is optional, as it defaults to 'term_id'
	            'terms'         => $cat_id,
	            'operator'      => 'IN' // Possible values are 'IN', 'NOT IN', 'AND'.
	        ),
	        array(
	            'taxonomy'      => 'product_visibility',
	            'field'         => 'slug',
	            'terms'         => 'exclude-from-catalog', // Possibly 'exclude-from-search' too
	            'operator'      => 'NOT IN'
	        )
	    )
	);
	$loop = new WP_Query($args);
	while ( $loop->have_posts() ) : $loop->the_post(); global $product;
		$prod_ids[]=$loop->post->ID;
		$prod_names[]=$loop->post->post_title;		
	endwhile;
	$subcatResultArray=array('prod_ids' => $prod_ids, 'prod_names' => $prod_names); 
    echo json_encode($subcatResultArray);
    wp_die();
}
add_action('wp_ajax_beeplug_ucdp_discount_insert_action', 'beeplug_ucdp_discount_insert');

function beeplug_ucdp_discount_insert(){

		global $wpdb; 		
		$cuid=sanitize_text_field($_POST["cust_list"]);
		//print_r($_POST);exit;
		$bee_table = $wpdb->prefix.'customer_discount';
		$del_query = "DELETE FROM $bee_table WHERE `cust_id` = %d";
		$del_query = $wpdb->prepare($del_query, array($cuid));
		$result_disc_list = $wpdb->query($del_query);
		
		 for($count = 0; $count < count($_POST["item_cat"]); $count++)
		 { 
		 		if($_POST["item_scat"][$count]==""){$scat=0;}else{$scat=sanitize_text_field($_POST["item_scat"][$count]);}
		 		if($_POST["item_prod"][$count]==""){$prod=0;}else{$prod=sanitize_text_field($_POST["item_prod"][$count]);}
		 	$data = array('cust_id'=>sanitize_text_field($_POST["cust_list"]),'cat_id'=>sanitize_text_field($_POST["item_cat"][$count]), 'scat_id'=>$scat, 'prod_id'=>$prod, 'disc_per'=>sanitize_text_field($_POST["disc_per"][$count]));
			$format = array('%d','%d','%d','%d','%d');
		 	$wpdb->insert($bee_table,$data,$format);
            $status = $wpdb->insert_id; 
		  	
			 
		}
		if($status>0)
		{
			echo 'ok';
		}
		wp_die();
		
}
// Variable and simple product displayed prices (removing sale price range)
add_filter( 'woocommerce_get_price_html', 'beeplug_ucdp_custom_get_price_html', 20, 2 );
function beeplug_ucdp_custom_get_price_html( $price, $product ) {

    if( $product->is_type('variable') )
    {
        if( is_user_logged_in() ){
			$s_min=$product->get_variation_sale_price('min');
			$s_max=$product->get_variation_sale_price('max');

			$current_user_id = get_current_user_id();
	    	$pid = $product->get_id();
	    	$product_cats = wp_get_post_terms($pid, 'product_cat');
	    	$cat_id=$product_cats[0]->parent;
	    	$scat_id=$product_cats[0]->term_id;
	    	if($cat_id==0)
	    		$cat_id=$scat_id;

	     	global $wpdb; 
			$bee_table = $wpdb->prefix.'customer_discount';

			$res_sql = 'SELECT disc_per FROM $bee_table WHERE cust_id=%d and prod_id=%d';
			$res_sql = $wpdb->prepare($res_sql, array($current_user_id,$pid));
			$result_prod = $wpdb->get_results($res_sql);
			
			if ( $result_prod )
			{
				$disc=$result_prod[0]->disc_per;
			}
			else
			{
				
				$scat_sql = 'SELECT disc_per FROM $bee_table WHERE cust_id=%d and prod_id=%d and scat_id=%d';
				$scat_sql = $wpdb->prepare($scat_sql, array($current_user_id,0,$scat_id));
				$result_scat = $wpdb->get_results($scat_sql);				
				if($result_scat)
				{
					$disc=$result_scat[0]->disc_per;
				}
				else
				{
					$scat_sql = 'SELECT disc_per FROM $bee_table WHERE cust_id=%d and prod_id=%d and scat_id=%d and cat_id=%d';
					$scat_sql = $wpdb->prepare($scat_sql, array($current_user_id,0,0,$cat_id));
					$result_cat = $wpdb->get_results($scat_sql);
					
					if($result_cat)
					{
						$disc=$result_cat[0]->disc_per;						
					}
					else
					{
						$disc=0;
					}
				}
			}

			$sale_min=$s_min-($s_min*($disc/100));
			$sale_max=$s_max-($s_max*($disc/100));
            $price_min  = wc_get_price_to_display( $product, array( 'price' => $sale_min ) );
            $price_max  = wc_get_price_to_display( $product, array( 'price' => $sale_max ) );
        } else {
            $price_min  = wc_get_price_to_display( $product, array( 'price' => $product->get_variation_regular_price('min') ) );
            $price_max  = wc_get_price_to_display( $product, array( 'price' => $product->get_variation_regular_price('max') ) );
        }

        if( $price_min != $price_max ){
            if( $price_min == 0 && $price_max > 0 )
                $price = wc_price( $price_max );
            elseif( $price_min > 0 && $price_max == 0 )
                $price = wc_price( $price_min );
            else
                $price = wc_format_price_range( $price_min, $price_max );
        } else {
            if( $price_min > 0 )
                $price = wc_price( $price_min);
        }
    }
    elseif( $product->is_type('simple') )
    {
        if( is_user_logged_in() ){
        	$current_user_id = get_current_user_id();
	    	$pid = $product->get_id();
	    	$product_cats = wp_get_post_terms($pid, 'product_cat');
	    	//print_r($product_cats);
	    	$cat_id=$product_cats[0]->parent;
	    	$scat_id=$product_cats[0]->term_id;
	    	if($cat_id==0)
	    		$cat_id=$scat_id;
	    	

	     	global $wpdb;
	     	$bee_table = $wpdb->prefix.'customer_discount';
	     	$res_sql = "SELECT disc_per FROM $bee_table WHERE cust_id=%d and prod_id=%d";
			$res_sql = $wpdb->prepare($res_sql, array($current_user_id,$pid));
			$result_prod = $wpdb->get_results($res_sql);
			//print_r($result_prod);
			if ( $result_prod )
			{
				$disc=$result_prod[0]->disc_per;
			}
			else
			{
				
				$scat_sql = "SELECT disc_per FROM $bee_table WHERE cust_id=%d and prod_id=%d and scat_id=%d";
				$scat_sql = $wpdb->prepare($scat_sql, array($current_user_id,0,$scat_id));
				$result_scat = $wpdb->get_results($scat_sql);
				if($result_scat)
				{
					$disc=$result_scat[0]->disc_per;
				}
				else
				{
					//echo "SELECT disc_per FROM $table WHERE cust_id=$current_user_id and prod_id=0 and scat_id=0 and cat_id=$cat_id";
					$scat_sql = "SELECT disc_per FROM $bee_table WHERE cust_id=%d and prod_id=%d and scat_id=%d and cat_id=%d";
					$scat_sql = $wpdb->prepare($scat_sql, array($current_user_id,0,0,$cat_id));
					$result_cat = $wpdb->get_results($scat_sql);
					if($result_cat)
					{
						$disc=$result_cat[0]->disc_per;					
					}
					else
					{
						$disc=0;
					}
				}
			}
			//echo $product->get_regular_price();
			$sim_price = ($product->get_sale_price()=='') ? $product->get_regular_price() : $product->get_sale_price();
			//$sim_price=$product->get_sale_price();
			$final_price_sim=$sim_price-($sim_price*($disc/100));
            $active_price = wc_get_price_to_display( $product, array( 'price' => $final_price_sim ) );
			
		}
        else{
            $active_price = wc_get_price_to_display( $product, array( 'price' => $product->get_regular_price() ) );
		}

        if( $active_price > 0 )
            $price = wc_price($active_price);
    }
	if( is_user_logged_in() ){
		//$price=$price-($price*(10/100));
		//if($disc>0){$dstr=$disc."% off on Trade Price";}else{$dstr="";}
    	//return $price. " (Excl. GST) ".$dstr;
    	if($disc>0){$dstr=$disc."% off on Actual Price";$strike="<s>".$sim_price."</s> ";}else{$dstr="";$strike="";}
    	return  $strike. $price. " ".$dstr;
	}
	else{
		//return $price." (Excl. GST) <span class='logged'>For trade pricing, please login <a href='https://beeplugin.andolasoft.co.in/my-account/'>here</a> ";
		return $price."<br><span class='logged'>For discount price, please login <a href='".get_site_url()."/my-account/'>here</a> ";
	}	
}

// Product Variation displayed prices
add_filter( 'woocommerce_available_variation', 'beeplug_ucdp_custom_variation_price', 10, 3);
function beeplug_ucdp_custom_variation_price( $data, $product, $variation ) {

    $reg_price = wc_get_price_to_display( $variation, array( 'price' => $variation->get_regular_price() ) );
    $sale_price = wc_get_price_to_display( $variation, array( 'price' => $variation->get_sale_price() ) );

    if( is_user_logged_in() ){

    	$current_user_id = get_current_user_id();
    	$pid = $product->get_id();
    	$product_cats = wp_get_post_terms($pid, 'product_cat');
    	$cat_id=$product_cats[0]->parent;
    	$scat_id=$product_cats[0]->term_id;
    	if($cat_id==0)
	    		$cat_id=$scat_id;

     	global $wpdb;
     	$bee_table = $wpdb->prefix.'customer_discount';
		$res_sql = "SELECT disc_per FROM $bee_table WHERE cust_id=%d and prod_id=%d";
		$res_sql = $wpdb->prepare($res_sql, array($current_user_id,$pid));
		$result_prod = $wpdb->get_results($res_sql);
		if ( $result_prod )
		{
			$disc=$result_prod[0]->disc_per;
		}
		else
		{
			$scat_sql = "SELECT disc_per FROM $bee_table WHERE cust_id=%d and prod_id=%d and scat_id=%d";
			$scat_sql = $wpdb->prepare($scat_sql, array($current_user_id,0,$scat_id));
			$result_scat = $wpdb->get_results($scat_sql);
			if($result_scat)
			{
				$disc=$result_scat[0]->disc_per;
			}
			else
			{
				$scat_sql = "SELECT disc_per FROM $bee_table WHERE cust_id=%d and prod_id=%d and scat_id=%d and cat_id=%d";
				$scat_sql = $wpdb->prepare($scat_sql, array($current_user_id,0,0,$cat_id));
				$result_cat = $wpdb->get_results($scat_sql);

				if($result_cat)
				{
					$disc=$result_cat[0]->disc_per;						
				}
				else
				{
					$disc=0;
				}
			}
		}

		$sale_pricep=$sale_price-($sale_price*($disc/100));
		if($disc>0)
		{
			$ostr=" <span style='color: #0a3a5b;font-weight: bold;'>(Excl. GST)</span> <span class='off_per'>".$disc."% off on Trade Price</span>";
			$data['price_html'] = "<del><span class='off_per'>$".$sale_price."</span></del>".wc_price( $sale_pricep ).$ostr;
		}
		else
		{
			$ostr=" <span style='color: #0a3a5b;font-weight: bold;'>(Excl. GST)</span>";
			if($sale_price==$reg_price)
			{
				$data['price_html'] = wc_price( $reg_price ).$ostr;
			}
			else
			{
				$data['price_html'] = "<del><span class='off_per'>$".$reg_price."</span></del>".wc_price( $sale_pricep ).$ostr;
			}
			
		}
        
	}
    else{
        $data['price_html'] = wc_price( $reg_price );
	}

    return $data;
}

// Set the correct prices in cart
add_action( 'woocommerce_before_calculate_totals', 'beeplug_ucdp_set_item_cart_prices', 1000, 1 );
function beeplug_ucdp_set_item_cart_prices( $cart ) {
    if ( is_admin() && ! defined( 'DOING_AJAX' ) )
        return;

    if ( did_action( 'woocommerce_before_calculate_totals' ) >= 2 )
        return;

    // Loop through cart items

    foreach ( $cart->get_cart() as $cart_item ){
        if( ! is_user_logged_in() ){
            $cart_item['data']->set_price( $cart_item['data']->get_regular_price() );
        }else{


        	$pid = $cart_item['product_id'];
        	$current_user_id = get_current_user_id();
	    	//$pid = $product->get_id();
	    	$product_cats = wp_get_post_terms($pid, 'product_cat');
	    	$cat_id=$product_cats[0]->parent;
	    	$scat_id=$product_cats[0]->term_id;
	    	if($cat_id==0)
	    		$cat_id=$scat_id;

	     	global $wpdb;
	     	$bee_table = $wpdb->prefix.'customer_discount';
			$res_sql = "SELECT disc_per FROM $bee_table WHERE cust_id=%d and prod_id=%d";
			$result_prod = $wpdb->prepare($res_sql, array($current_user_id,$pid));
			if ( $result_prod )
			{
				$disc=$result_prod[0]->disc_per;
			}
			else
			{
				$scat_sql = "SELECT disc_per FROM $bee_table WHERE cust_id=%d and prod_id=%d and scat_id=%d";
				$scat_sql = $wpdb->prepare($scat_sql, array($current_user_id,0,$scat_id));
				$result_scat = $wpdb->get_results($scat_sql);
				if($result_scat)
				{
					$disc=$result_scat[0]->disc_per;
				}
				else
				{
					$scat_sql = "SELECT disc_per FROM $bee_table WHERE cust_id=%d and prod_id=%d and scat_id=%d and cat_id=%d";
					$scat_sql = $wpdb->prepare($scat_sql, array($current_user_id,0,0,$cat_id));
					$result_cat = $wpdb->get_results($scat_sql);
					if($result_cat)
					{
						$disc=$result_cat[0]->disc_per;						
					}
					else
					{
						$disc=0;
					}
				}
			}
			//echo $disc;
			$sale_price=$cart_item['data']->get_sale_price();
			$reg_price=$cart_item['data']->get_regular_price();
			if($sale_price>0)
			{
				$final_sale=$sale_price-($sale_price*($disc/100));
			}
			else
			{
				$final_sale=$reg_price-($reg_price*($disc/100));
			}
			//echo $final_sale;						
			$cart_item['data']->set_price( $final_sale );
			//wp_dequeue_script( 'wc-cart-fragments' );
		}
    }
}
// add_action( 'admin_enqueue_scripts', 'bee_scripts', 11 ); 
 
// function bee_scripts() { 
//    wp_enqueue_script( 'bee_js_script', 'https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha1/dist/js/bootstrap.bundle.min.js" integrity="sha384-w76AqPfDkMBDXo30jS1Sgez6pr3x5MlQ1ZAGC+nuZB+EYdgRZgiwxhTBTkF7CXvN', array(), '1.0' );   
// }
// add_action( 'admin_enqueue_styles', 'bee_disable_woocommerce_cart_fragments', 11 ); 
 
// function bee_disable_woocommerce_cart_fragments() { 
//    //wp_dequeue_script( 'wc-cart-fragments' );   
// }
// Remove sale badge
// add_action( 'admin_enqueue_scripts', 'bee_scripts', 11 ); 
 
// function bee_scripts() { 
//    wp_enqueue_script( 'bee_js_script', 'https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha1/dist/js/bootstrap.bundle.min.js" integrity="sha384-w76AqPfDkMBDXo30jS1Sgez6pr3x5MlQ1ZAGC+nuZB+EYdgRZgiwxhTBTkF7CXvN', array(), '1.0' );   
// }
// add_action( 'admin_enqueue_styles', 'bee_disable_woocommerce_cart_fragments', 11 ); 
 
// function bee_disable_woocommerce_cart_fragments() { 
//    //wp_dequeue_script( 'wc-cart-fragments' );   
// }
// Remove sale badge
remove_action( 'woocommerce_before_shop_loop_item_title', 'woocommerce_show_product_loop_sale_flash', 10 );
remove_action( 'woocommerce_before_single_product_summary', 'woocommerce_show_product_sale_flash', 10 );


add_filter( 'woocommerce_cart_item_price', 'beeplug_ucdp_change_item_price', 10, 3 );
function beeplug_ucdp_change_item_price( $price, $cart_item, $cart_item_key ) {

    $price = $cart_item['data']->get_price_html();

    return $price;
}


?>